unit AtulLib;
{
This library is valid on 24/01/2024

24/01/2024 + StringInList function

31/01/2021 
    function isUrl


11/04/2019 
    procedure OpenFolder
    function SpsOnly
    ExcludeTrailingSpase
    function IsBadSymfol
    Function ExtractFolderName

  Updated 13/04/2019 
    Function FindFolders

          14/04/2019
    function SavePictureToDisk
          17/04/2019
    function ifSubString
    procedure AutoSizeGridColumn

    11/04/2023
    function  ExcludeSpase
}

interface
uses
 Forms, Windows, Messages, SysUtils, Classes, IniFiles, shellApi, FileCtrl,
 Contnrs, Vcl.Dialogs, Graphics, Vcl.ExtCtrls, JPEG, Math, Vcl.Grids ;

type
   DWORDLONG = UInt64;

  PMemoryStatusEx = ^TMemoryStatusEx;

  TMemoryStatusEx = packed record
    dwLength: DWORD;
    dwMemoryLoad: DWORD;
    ullTotalPhys: DWORDLONG;
    ullAvailPhys: DWORDLONG;
    ullTotalPageFile: DWORDLONG;
    ullAvailPageFile: DWORDLONG;
    ullTotalVirtual: DWORDLONG;
    ullAvailVirtual: DWORDLONG;
    ullAvailExtendedVirtual: DWORDLONG;
  end;


  tDiskParam = record
   Letter : string;
   Digit : byte;
   Exists : boolean;
   DiskType : string;
   Capacity : LongInt;
  end;{record}

  TDiskParamEx = Class
   Letter : string;
   Digit : byte;
   DiskType : string;
   Capacity : LongInt;
  End; {class}

/////////////////////////////////////

//      
function StringInList(const str: String; List: TStrings): Boolean;

//     
function isUrl(url: String): boolean;

//    
function SetPCSystemTime(tDati: TDateTime): Boolean;


//        
function SpsOnly(Const s: string):boolean;

//    
function ExcludeTrailingSpase(const s: string): String;

//      
function  ExcludeSpase(const s: string): String;

//      
function IsBadSymfol(const s: ansistring): Boolean;

function MakeTime(Dur:Integer):String;

//   
Function SendToRecycleBin(FName: string):Integer;

//  
Function CopyFileTo(FFrom, FTo: string;MoveIt:boolean):Integer;

//         
function AutoMakeFileName: string;

//   
procedure GetDrives(Var DriveList: TStringList);

//    2
function GetDrivesEx (Var DriveListEx: TObjectList): integer;

//    
function DriveExists(Drive: Byte): Boolean;

//   
function FindFiles(Const Folder,Mask: String; Var FileList: TStringList; Const SubFolders: Boolean ): Boolean;

//    ,    
function AppendSlash(const S:String): string;

//    ()     -
// .     ,   -1
function ExtractFileNumber(Const S: string): Integer;

//    
function RemoveFileExt(Const S: string): String;

//      :
function ExtractDriveLetter(Const S: string): String;

//,      NT
Function IsNT: Boolean;

//    NT
Function PowerOffNT : Boolean;

//    9x
Function PowerOff9x : Boolean;

//   
Function AppPath:String;

// TRUE      
//   
function InputEmpty(const S: String):boolean;

//       
function RunFile(FName: String): boolean;

//      
procedure RunUrl(StrUrl: String);

//   
procedure OpenFolder(Path: String);

function GetVersionStr (FName: String): String;

function GetFileVersion(const sFilename: String; var nValue1,nValue2,nValue3,nValue4: Integer): String;

//       
function AddZeros(NZ: Word; Value: DWORD): string;

//       
//   
procedure MemoryStatStrKb(var TotalPhys ,AvailPhys,TotalPageFile : string);

//   
function GetCPUSpeed: Double;

//  
function GetCPUCount: Cardinal;

function GlobalMemoryStatusEx(var lpBuffer: TMemoryStatusEx): BOOL; stdcall; external kernel32;

//     
Function ExtractFolderName (const S: String): String;

//   
Function FindFolders (Const RootFolder : string; Var FolderList: TStringList): Boolean;

//   TImage    JPG
function SavePictureToDisk(var Image: TImage; MaxPicSize : integer; FileName: String): Boolean;

//        True  False
function ifSubString(const subString : string;   const mainString : string): boolean;

//    TStringGrid.
procedure AutoSizeGridColumn(Grid: TStringGrid; column: integer; AddPixels: Integer);

function GetGradient (FromColor, ToColor, minValue, MaxValue, Value : integer ): TColor;

function GetGradient2 (minValue, MaxValue, Value : integer ): TColor;

implementation

///===========================================================================
// : nValue1,2,3,4    ,     !
function GetFileVersion(const sFilename: String; var nValue1,nValue2,nValue3,nValue4: Integer): String;
var
   pInfo,pPointer: Pointer;
   nSize: DWORD;
   nHandle: DWORD;
   pVerInfo: PVSFIXEDFILEINFO;
   nVerInfoSize: DWORD;
begin
   Result:='?.?.?.?';
   nValue1:=-1;
   nValue2:=-1;
   nValue3:=-1;
   nValue4:=-1;

   nSize:=GetFileVersionInfoSize(PChar(sFilename),nHandle);
   if (nSize <>0) then begin
     GetMem(pInfo,nSize);
     try
       FillChar(pInfo^,nSize,0);

       if (GetFileVersionInfo(PChar(sFilename),nHandle,nSize,pInfo)) then begin
         nVerInfoSize:=SizeOf(VS_FIXEDFILEINFO);
         GetMem(pVerInfo,nVerInfoSize);
         try
           FillChar(pVerInfo^,nVerInfoSize,0);
           pPointer:=Pointer(pVerInfo);
           VerQueryValue(pInfo,'\',pPointer,nVerInfoSize);
           nValue1:=PVSFIXEDFILEINFO(pPointer)^.dwFileVersionMS shr 16;
           nValue2:=PVSFIXEDFILEINFO(pPointer)^.dwFileVersionMS and $FFFF;
           nValue3:=PVSFIXEDFILEINFO(pPointer)^.dwFileVersionLS shr 16;
           nValue4:=PVSFIXEDFILEINFO(pPointer)^.dwFileVersionLS and $FFFF;

           Result:=IntToStr(nValue1)+'.'+IntToStr(nValue2)+'.'+IntToStr(nValue3)+'.'+IntToStr(nValue4);
         finally
           FreeMem(pVerInfo,nVerInfoSize);
         end;
       end;
     finally
       FreeMem(pInfo,nSize);
     end;
   end;
end;//GetVersion
//===========================================================================

function GetVersionStr (FName: String): String;
var
 nValue1,nValue2,nValue3,nValue4: integer;
begin
   result:=GetFileVersion(FName,nValue1,nValue2,nValue3,nValue4);

end; //GetVersionStr
//===========================================================================

//   
procedure OpenFolder(Path: string);
begin
 ShellExecute(Application.Handle,PChar('explore'),
   PChar(Path),nil,nil,SW_SHOWNORMAL);
end;

function SetPCSystemTime(tDati: TDateTime): Boolean;
var
 tSetDati: TDateTime;
 vDatiBias: Variant;
 tTZI: TTimeZoneInformation;
 tST: TSystemTime;

begin

  GetTimeZoneInformation(tTZI);
  vDatiBias := tTZI.Bias / 1440;
  tSetDati := tDati + vDatiBias;

  with tST do
   begin

    wYear := StrToInt(FormatDateTime('yyyy', tSetDati));

    wMonth := StrToInt(FormatDateTime('mm', tSetDati));

    wDay := StrToInt(FormatDateTime('dd', tSetDati));

    wHour := StrToInt(FormatDateTime('hh', tSetDati));

    wMinute := StrToInt(FormatDateTime('nn', tSetDati));

    wSecond := StrToInt(FormatDateTime('ss', tSetDati));

    wMilliseconds := 0;

   end;

  SetPCSystemTime := SetSystemTime(tST);

end;


function MakeTime(Dur:Integer):String;
var
  s,m,h:integer;
  ss,mm,hh: string;
begin
  h:= Dur div 3600;
  m:= (Dur mod 3600)div 60;
  s:= (((Dur mod 3600) mod 60)mod 60);
  hh:=IntToStr(h);
  if m<10 then mm:='0'+inttostr(m) else mm:=inttostr(m);
  if s<10 then ss:='0'+inttostr(s) else ss:=inttostr(s);
  Result := hh+':'+mm+':'+ss;
end;//MakeTime

//===========================================================================

//   
Function SendToRecycleBin(FName: string):Integer;
var
  SHF: TSHFileOpStruct;
begin
  FName:=Fname+#0;
  FILLCHAR( SHF, SIZEOF( SHF ), 0 );
  with SHF do begin
     Wnd := Application.Handle;
     wFunc := FO_DELETE;
     pFrom := PChar(FName);
     fFlags := FOF_ALLOWUNDO OR FOF_NOCONFIRMATION OR FOF_SILENT;
  end;
  Result:=SHFileOperation(SHF);
  if Result<>0
   then if SHF.fAnyOperationsAborted
    then Result:= 1
    else Result:= 2;
end;//SendToRecycleBin

//===========================================================================

//    
Function CopyFileTo(FFrom, FTo: string;MoveIt:boolean):Integer;
var
  SHF: TSHFileOpStruct;
begin
  FFRom:=FFRom+#0;
  FTo:=FTo+#0;
  FILLCHAR( SHF, SIZEOF( SHF ), 0 );
  with SHF do begin
     Wnd := Application.Handle;
     if MoveIt then wFunc := FO_MOVE
      else wFunc := FO_COPY;
     pFrom := PChar(FFRom);
     pTo := PChar(FTo);
     fFlags :=
      FOF_ALLOWUNDO OR FOF_NOCONFIRMATION;
  end;
  Result:=SHFileOperation(SHF);
  if Result<>0
   then if SHF.fAnyOperationsAborted
    then Result:= 1
    else Result:= 2;
end;//CopyFileTo

//===========================================================================

//         
function AutoMakeFileName: string;
var
 Year,Month,Day,Hour,Min,Sec,mSec: Word ;
 sYear,sMonth,sDay,sHour,sMin,sSec{,sNumInRow}: string;
begin
 DecodeDate(Date,Year,Month,Day);
 DecodeTime(Time,Hour,Min,Sec,mSec);
 sYear:=Copy(intToStr(Year),3,2);
 sMonth:=IntToStr(Month);if Length(sMonth)=1 then sMonth:='0'+sMonth;
 sDay:=IntToStr(Day);if Length(sDay)=1 then sDay:='0'+sDay;
 sHour:=IntToStr(Hour);if Length(sHour)=1 then sHour:='0'+sHour;
 sMin:=IntToStr(Min);if Length(sMin)=1 then sMin:='0'+sMin;
 sSec:=IntToStr(Sec);if Length(sSec)=1 then sSec:='0'+sSec;
 {sNumInRow:=IntToStr(FileCounter);
 case length(sNumInRow) of
  1:sNumInRow:='0'+'0'+sNumInRow;
  2:sNumInRow:='0'+sNumInRow;
 end;}{Case}
 Result:=sYear+sMonth+sDay+'_'+sHour+sMin+sSec{+'_'+sNumInRow};
end; {AutoMakeFileName}

//===========================================================================

{      }
function DriveExists(Drive: byte): Boolean;
var ErrorMode: word;

begin
  //Result := Boolean (GetLogicalDrives And (1 shl Drive));
  ErrorMode := SetErrorMode(SEM_FailCriticalErrors);
     try
      //  1 = a, 2 = b, 3 = c,  ..
      if DiskSize(Drive+1) = -1 then
         Result := False
      else
        Result := True;
     finally
      //      
      SetErrorMode(ErrorMode);
     end;


end;{DriveExists}

//===========================================================================

//   
procedure GetDrives(Var DriveList: TStringList);
var
 i:byte;
 darr: array [0..15] of tDiskParam;
begin
  DriveList.Clear;
  for i:= 0 to 15 do
   begin
     darr[i].Letter:=chr(i+65)+':';
     darr[i].Exists:= DriveExists(i);
     case GetDriveType(pchar(darr[i].Letter+'\')) of
         0: darr[i].DiskType:='Unknown';
         1: darr[i].DiskType:='No Root Dir';
         2: darr[i].DiskType:='Removable';
         3: darr[i].DiskType:='Fixed (HDD)';
         4: darr[i].DiskType:='Network';
         5: darr[i].DiskType:='CD-Rom';
         6: darr[i].DiskType:='RAM-Disk';
         end{case};
     darr[i].Digit:=i+1;
     if (darr[i].DiskType='HDD') or (darr[i].DiskType='network') then
      darr[i].Capacity:=(DiskFree(darr[i].Digit)div 1024) div 1024
      else darr[i].Capacity:=0;
     if (darr[i].Exists) and ((darr[i].DiskType='HDD') or (darr[i].DiskType='network')) then
         DriveList.Add(
         darr[i].Letter +' '+ darr[i].DiskType+' '+IntToStr(darr[i].Capacity)+' Mb');
   end;
end;//GetDrives

//===========================================================================

Function GetDrivesEx (Var DriveListEx: TObjectList): integer;
var i,idx: Integer;
begin
  //result:=0;
  DriveListEx.Clear;
  for I := 0 to 25 do
    begin
      if (not DriveExists(i)) then Continue;

      idx := DriveListEx.Add(TDiskParamEx.create);

      (DriveListEx[idx] as TDiskParamEx).Letter := chr(i+65)+':';

      case GetDriveType(pchar((DriveListEx[idx] as TDiskParamEx).Letter+'\')) of
         0: (DriveListEx[idx] as TDiskParamEx).DiskType:='Unknown';
         1: (DriveListEx[idx] as TDiskParamEx).DiskType:='No Root Dir';
         2: (DriveListEx[idx] as TDiskParamEx).DiskType:='Removable';
         3: (DriveListEx[idx] as TDiskParamEx).DiskType:='Fixed';
         4: (DriveListEx[idx] as TDiskParamEx).DiskType:='Network';
         5: (DriveListEx[idx] as TDiskParamEx).DiskType:='CD';
         6: (DriveListEx[idx] as TDiskParamEx).DiskType:='RAM-Disk';
      else  (DriveListEx[idx] as TDiskParamEx).DiskType:='Unknown';
      end; {case}

      (DriveListEx[idx] as TDiskParamEx).Digit:=i+1;
      if (((DriveListEx[idx] as TDiskParamEx).DiskType = 'Removable') or
          ((DriveListEx[idx] as TDiskParamEx).DiskType = 'Fixed') or
          ((DriveListEx[idx] as TDiskParamEx).DiskType = 'Network') or
          ((DriveListEx[idx] as TDiskParamEx).DiskType = 'RAM-Disk'))
        then (DriveListEx[idx] as TDiskParamEx).Capacity :=
          (DiskFree((DriveListEx[idx] as TDiskParamEx).Digit)div 1024) div 1024;

    end; //For

  result := DriveListEx.Count;

end;//GetDrivesEx

//===========================================================================


function FindFiles(Const Folder,Mask: String; Var FileList: TStringList; Const SubFolders: Boolean ): Boolean;
Var FindOK: boolean;
 procedure FindRecurse(Dir: String);
  var
   SR: TSearchRec;
   ires: Integer;
 begin
  ChDir(Dir);//      

  //  ,  
  ires:=FindFirst(Mask, faHidden+faSysFile, SR);
  while ires =0 do
   begin
    FileList.Add(IncludeTrailingBackslash(GetCurrentDir)+SR.Name);
    ires := FindNext(SR);
   end;//while
  FindClose(SR);
  if (FileList.Count>0) then FindOK:=True;
  //  

  //  
  if SubFolders then
  begin
     ires := FindFirst('*.*', faDirectory, SR);
     while ires =0 do
     begin
       application.ProcessMessages;
       if(SR.Name<>'.')and(SR.Name<>'..')and((SR.Attr and faDirectory)<>0)
          //   FindFiles
          then FindRecurse(SR.Name);
       ires:=FindNext(SR);
     end;//while ires =0
     FindClose(SR);
     //   
     chDir('..');
  end;//if SubFolders

 end;//FindRecurse

begin
 FindOK:= False;
 FileList.Clear;
 FindRecurse(Folder);
 Result:= FindOK;
end;//FindFiles

//===========================================================================

function AppendSlash(const S:String): string;
begin
  if copy(s,length(s),1)<>'\' then result:=s+'\' else
    result:=s;
end;//AppendSlash

//===========================================================================
function ExtractFileNumber(Const S: string): Integer;
var
 fn: string;
 sn: string;// - 
 Code: Integer;
begin
 Result:=-1;
 fn:= ExtractFileName(S);
 //  .   a_0000,   6 
 if (Length(RemoveFileExt(fn)) < 6) then exit;
 //5-      '_';
 if not (Copy(RemoveFileExt(fn),Length(RemoveFileExt(fn))-4,1)='_')
   then Exit;
 sn:=Copy(RemoveFileExt(fn),Length(RemoveFileExt(fn))-3,4);
 Val(sn,result,Code);
 if (Code<>0) then Result:=-1;
end;//ExtractFileNumber

//===========================================================================
//    
function RemoveFileExt(Const S: string): String;
begin
 result:=S;;
 if (ExtractFileExt(S)='') then Exit;
 Delete(result,
        (Length(S)+1)-Length(ExtractFileExt(S)),
          Length(ExtractFileExt(S)));
end;//RemoveFileExt
//===========================================================================

//      :
function ExtractDriveLetter(Const S: string): String;
begin
  result:='';
  if Length(s)<2 then Exit;
  result:=Copy(S,1,1)+':';
end;//ExtractDriveLetter
//===========================================================================

//,      NT
Function IsNT: Boolean;
begin
  result:= getVersion < $80000000;
end;//IsNT
//===========================================================================

//    NT
Function PowerOffNT : Boolean;
var
 hToken: THandle;
 Luid: TLargeInteger;
 tkp: TTokenPrivileges;
 ReturnLength: Cardinal;
begin
 Result:=False;
 if OpenProcessToken(GetCurrentProcess, TOKEN_ADJUST_PRIVILEGES,hToken)
  then
  begin
    lookupPrivilegeValue(nil, 'SeShutdownPrivilege', Luid);
    tkp.Privileges[0].Luid := Luid;
    tkp.PrivilegeCount := 1;
    tkp.Privileges[0].Attributes:=SE_PRIVILEGE_ENABLED;
    if AdjustTokenPrivileges(hToken, False,tkp, 0, Nil, Returnlength)
     then if not ExitWindowsEX(EWX_SHUTDOWN or EWX_POWEROFF, 0)
      then Result:=False else Result:=True;
  end;
end;//PowerOffNT
//===========================================================================

//    9x
Function PowerOff9x : Boolean;
begin
  Result:=False;
  if not ExitWindowsEx(EWX_Force or
                       EWX_PowerOff or
                       EWX_ShutDown, 0) then Result:=False;
end;//PowerOff9x
//===========================================================================

//   
Function AppPath:String;
begin
 Result:= AppendSlash(ExtractFilePath(Application.ExeName));
end;//AppPath

//===========================================================================
function InputEmpty(const S: String):boolean;
var i: integer;
begin
  Result:=True;
  if (s='') or (s=' ') then exit;
  for i:=1 to Length(S) do
  begin
    if S[i]<>' ' then Result:=False;
  end;
end;//InputEmpty
//===========================================================================
//       
function RunFile(FName: String): boolean;
var ttt: Integer;
begin
  if (not FileExists(FName)) then
  begin
    Result := False;
    Exit;
  end;
  ttt:=ShellExecute(0, Nil,Pchar(FName),nil,Nil, SW_NORMAL);
  if ttt<=32 then Result := false else Result := True;

end;//RunFile
//===========================================================================

procedure RunUrl(StrUrl: String);
   begin
     if AnsiUpperCase(Copy(StrUrl,1,7))=('HTTP://') then
        shellExecute(0, Nil,Pchar(StrUrl),nil,Nil, SW_NORMAL)
     else
     if AnsiUpperCase(Copy(StrUrl,1,8))=('HTTPS://') then
        shellExecute(0, Nil,Pchar(StrUrl),nil,Nil, SW_NORMAL)
     else
     if AnsiUpperCase(Copy(StrUrl,1,6))=('FTP://') then
        shellExecute(0, Nil,Pchar(StrUrl),nil,Nil, SW_NORMAL)
     else
      begin
         StrUrl := 'http://'+StrUrl ;
         shellExecute(0, Nil,Pchar(StrUrl),nil,Nil, SW_NORMAL);
      end;

   end;

//===========================================================================
//       
function AddZeros(NZ: Word; Value: DWORD): string;
var s: string;
    i,c,l: Word;
begin
  s:=IntToStr(Value);
  Result := s;
  l:= Length(s);
  if l < NZ then
  begin
    c := NZ - l;
    for I := 1 to c do
    begin
      Result := '0' + Result;
    end;

  end;

end;

//===========================================================================
///  //       
//   
procedure MemoryStatStrKb(var TotalPhys ,AvailPhys,TotalPageFile : string);
Var
 Vmem:TMemoryStatusEx;
begin

  // initialize the structure
  FillChar(Vmem, SizeOf(Vmem), 0);
  Vmem.dwLength := SizeOf(Vmem);
  // check return code for errors
  Win32Check(GlobalMemoryStatusEx(Vmem));


 GlobalMemoryStatusEx(Vmem);
 AvailPhys:=
  FormatFloat('#,###', Vmem.ullAvailPhys / 1024) + ' KB Available';

 TotalPhys :=
  FormatFloat('#,###', Vmem.ullTotalPhys / 1024) + ' KB Total';

 TotalPageFile:=
  FormatFloat('#,###', Vmem.ullTotalPageFile / 1024) + ' KB';

end;//MemoryStatStrKb
//===========================================================================

//    
function GetCPUSpeed: Double;
const DelayTime = 500; // measure time in ms
var
  TimerHi, TimerLo: DWORD;
  PriorityClass, Priority: Integer;
begin
  PriorityClass := GetPriorityClass(GetCurrentProcess);
  Priority := GetThreadPriority(GetCurrentThread);
  SetPriorityClass(GetCurrentProcess, REALTIME_PRIORITY_CLASS);
  SetThreadPriority(GetCurrentThread, THREAD_PRIORITY_TIME_CRITICAL);
  Sleep(10);
  asm
   dw 310Fh // rdtsc
   mov TimerLo, eax
   mov TimerHi, edx
  end;
  Sleep(DelayTime);
  asm
   dw 310Fh // rdtsc
   sub eax, TimerLo
   sbb edx, TimerHi
   mov TimerLo, eax
   mov TimerHi, edx
  end;
  SetThreadPriority(GetCurrentThread, Priority);
  SetPriorityClass(GetCurrentProcess, PriorityClass);
  Result := TimerLo / (1000.0 * DelayTime);
end;//GetCPUSpeed
//===========================================================================

function GetCPUCount: Cardinal;
var   s: TSystemInfo;
begin
  GetSystemInfo(s);
  Result := s.dwNumberOfProcessors;
end;//GetCPUCount
//===========================================================================

function SpsOnly(Const s: string):boolean;
  var i: integer;
begin
  Result := true;
  if s='' then exit;
  for i:=1 to Length(s) do
   if s[i]<>' ' then
   begin
     Result := false;
     Break;
   end;
end;
//===========================================================================

function ExcludeTrailingSpase(const s: string): String;
var i: integer;

begin
  result := s;
  if SpsOnly(s) then
  begin
    result:='';
    exit;
  end;
  for i:=length(s) downto 1 do
   if s[i]<>' ' then break
    else delete(result,i,1);
end;
//===========================================================================


function  ExcludeSpase(const s: string): String;
begin
  result := s;
  if SpsOnly(s) then
    begin
      result:='';
      exit;
    end;
  While result[1]=' ' do Delete(result, 1, 1); //  
  While result[Length(result)]=' ' do Delete(result, Length(result), 1); //  

end;
//===========================================================================


function IsBadSymfol(const s: ansistring): Boolean;
var i: integer;
begin
  result := False;
  for i:=1 to length(s) do
     if  not (s[i] in [''..'', ''..'', 'A'..'Z', 'a'..'z', '_', ' ', '-', '0'..'9']) then
     begin
       result := True;
       exit
     end;
end;



Function ExtractFolderName (const S: String): String;
var i:integer;
    s1,s2:String;
begin
  result:='';
  s2:='';
  s1:=s;
  if Copy(s1,Length(s1),1)='\' then Delete(s1,Length(s1),1);
  for i:=Length(s1) downTo 1 do
  begin
     if s1[i]='\' then break;
     s2:=s2+s1[i];
  end;
  s1:='';
  for i:=Length(s2) downto 1 do s1:=s1+s2[i];
  Result := s1;
end;
//===========================================================================

//   
Function FindFolders (Const RootFolder : string; Var FolderList: TStringList): Boolean;
var
  sr: TSearchRec;
  Path: string;
begin
  result := false;
  Path := RootFolder;
  if FindFirst(Path + '*.*', faAnyFile, sr) = 0 then
  begin
    repeat
    if (sr.Attr and faDirectory) <> 0 then  //    - 
      begin
      if (sr.Name <> '.') and (sr.Name <> '..') then  //   
        begin
         FolderList.Add(sr.Name);
         result := true;
        end;
      end;
    until FindNext(sr) <> 0;
  end;

  FindClose(sr);

end;
//===========================================================================
//   TImage    JPG
function SavePictureToDisk(var Image: TImage; MaxPicSize : integer; FileName: String): Boolean;
var ok: boolean;
     scale : Double;
     h,w : integer;
     bmp: TBItmap;
begin

Result:=true;
 try
  ok:= Image.Picture.Graphic is TJPEGImage;
  if not ok then
  begin
    Result:=false;
    exit;
  end;

    //     TBitmap
   if  MaxPicSize > 9 then begin

      h := TJPEGImage(Image.Picture.Graphic).Height;
      w := TJPEGImage(Image.Picture.Graphic).Width;
      scale := Min(MaxPicSize / w, MaxPicSize / h);
      if scale < 1 then
      begin
        bmp:= Tbitmap.Create;
        bmp.Width := Round( w * scale );
        bmp.Height:= Round( h * scale );
        bmp.Canvas.StretchDraw( bmp.Canvas.Cliprect, TJPEGImage(Image.Picture.Graphic) );
        TJPEGImage(Image.Picture.Graphic).Assign(bmp);
        TJPEGImage(Image.Picture.Graphic).SaveToFile(FileName);
        bmp.free;
      end
      else  TJPEGImage(Image.Picture.Graphic).SaveToFile(FileName);

   end else TJPEGImage(Image.Picture.Graphic).SaveToFile(FileName);

 Except
  on Exception do Result:=False;
 end;


end;
//===========================================================================

//        True  False
function ifSubString(const subString : string;   const mainString : string): boolean;
var position : integer;
begin
  position := AnsiPos(AnsiUpperCase(subString), AnsiUpperCase(mainString));
  if position = 0 then result := false else  result := true;

end;
//===========================================================================

//    TStringGrid.
procedure AutoSizeGridColumn(Grid: TStringGrid; column: integer; AddPixels: Integer);
var
 i: integer;
 temp: integer;
 max: integer;

begin
  max := 0;
  for i := 0 to (Grid.RowCount - 1) do begin
    temp := Grid.Canvas.TextWidth(grid.cells[column, i]);
    if temp > max then max := temp;
  end;

 Grid.ColWidths[column] := Max + Grid.GridLineWidth + AddPixels;

end;
//===========================================================================

function GetGradient (FromColor, ToColor, minValue, MaxValue, Value : integer ): TColor;
var
 fromR, fromG, fromB, toR, toG, toB : byte;
 deltaR,  deltaG, deltaB : byte;
 R, G, B : Byte;
 Color: Longint;
begin

  Color := ColorToRGB(FromColor);
  fromR := Color;
  fromG := Color shr 8;
  fromB := Color shr 16;
  Color := ColorToRGB(ToColor);
  toR := Color;
  toG := Color shr 8;
  toB := Color shr 16;

  deltaR := Round((toR - fromR) / MaxValue);
  deltaG := Round((toG - fromG) / MaxValue);
  deltaB := Round((toB - fromB) / MaxValue);
  R := fromR + Value * deltaR;
  G := fromG + Value * deltaG;
  B := fromB + Value * deltaB;
  result := RGB(R, G, B);
  //Result := R + G * 256 + B * 256 * 256

end;
//===========================================================================


function GetGradient2 (minValue, MaxValue, Value : integer ): TColor;
var Proc: integer;
begin
  if MaxValue <= minValue then begin
     MaxValue := 100;
     minValue := 0;
  end;

  if Value > MaxValue  then Value := MaxValue;

  Proc := trunc (((Value - minValue) / (MaxValue - minValue)) * 100);

  if Proc in [0..9]    then result  := 7697919 else
  if Proc in [10..19]  then result  := 7708415 else
  if Proc in [20..29]  then result  := 7724543 else
  if Proc in [30..39]  then result  := 7863037 else
  if Proc in [40..49]  then result  := 7733147 else
  if Proc in [50..59]  then result  := 11534197 else
  if Proc in [60..69]  then result  := 15203958 else
  if Proc in [70..79]  then result  := 15203958 else
  if Proc in [80..89]  then result  := 16641143 else
  if Proc in [90..100] then result  := 16561272 else
                            result  := 16777215;

end;
//===========================================================================

function isUrl(url: String): boolean;
var s : string;
begin
  s := lowercase(trim(url)); //    
  result := true;

  //     
  if pos(' ', s) <> 0 then begin
    result := false;
    exit;
  end;


  if ((pos('http://', s) <> 1) and
     (pos('https://', s) <> 1) and
     (pos('ftp://',   s) <> 1))
     then result := false;


end;
//===========================================================================

function StringInList(const str: String; List: TStrings): Boolean;
var i: integer;

begin
  result := false ;
  if List.Count < 1 then  exit;
  for i := 0 to List.Count-1 do begin
     if List[i] =  str then begin
       result := true;
       break;
     end;


  end;


end;


end.
